#ifndef MESH_H
#define MESH_H

#define NODECOUNT 32
#define TRICOUNT 60

#define NODE(a, b) (long)(pgm_read_dword(&nodes[a][b]))
#define EDGE(a, b) pgm_read_byte(&faces[a][b])

const long nodes[NODECOUNT][3] PROGMEM = {
  {(long)(-28.98*PRES), (long)(0.0*PRES), (long)(-0.0*PRES)},
  {(long)(-25.097422*PRES), (long)(0.0*PRES), (long)(14.49*PRES)},
  {(long)(-12.548704*PRES), (long)(21.735*PRES), (long)(14.49*PRES)},
  {(long)(-14.49*PRES), (long)(25.097408*PRES), (long)(-0.0*PRES)},
  {(long)(-14.49*PRES), (long)(0.0*PRES), (long)(25.097422*PRES)},
  {(long)(-7.245*PRES), (long)(12.548704*PRES), (long)(25.097422*PRES)},
  {(long)(-7.245*PRES), (long)(12.548704*PRES), (long)(-25.097422*PRES)},
  {(long)(-12.548704*PRES), (long)(21.735*PRES), (long)(-14.49*PRES)},
  {(long)(12.548704*PRES), (long)(21.735*PRES), (long)(-14.49*PRES)},
  {(long)(7.245*PRES), (long)(12.548704*PRES), (long)(-25.097422*PRES)},
  {(long)(14.49*PRES), (long)(25.097408*PRES), (long)(-0.0*PRES)},
  {(long)(12.548704*PRES), (long)(21.735*PRES), (long)(14.49*PRES)},
  {(long)(7.245*PRES), (long)(12.548704*PRES), (long)(25.097422*PRES)},
  {(long)(25.097408*PRES), (long)(-0.0*PRES), (long)(-14.49*PRES)},
  {(long)(14.489986*PRES), (long)(-0.0*PRES), (long)(-25.097422*PRES)},
  {(long)(28.979986*PRES), (long)(-0.0*PRES), (long)(-0.0*PRES)},
  {(long)(25.097408*PRES), (long)(-0.0*PRES), (long)(14.49*PRES)},
  {(long)(14.489986*PRES), (long)(-0.0*PRES), (long)(25.097422*PRES)},
  {(long)(12.548704*PRES), (long)(-21.735*PRES), (long)(-14.49*PRES)},
  {(long)(7.244986*PRES), (long)(-12.548704*PRES), (long)(-25.097422*PRES)},
  {(long)(14.489986*PRES), (long)(-25.097422*PRES), (long)(-0.0*PRES)},
  {(long)(12.548704*PRES), (long)(-21.735*PRES), (long)(14.49*PRES)},
  {(long)(7.244986*PRES), (long)(-12.548704*PRES), (long)(25.097422*PRES)},
  {(long)(-12.548718*PRES), (long)(-21.735*PRES), (long)(-14.49*PRES)},
  {(long)(-7.245014*PRES), (long)(-12.548704*PRES), (long)(-25.097422*PRES)},
  {(long)(-14.490014*PRES), (long)(-25.097408*PRES), (long)(-0.0*PRES)},
  {(long)(-12.548718*PRES), (long)(-21.735*PRES), (long)(14.49*PRES)},
  {(long)(-7.245014*PRES), (long)(-12.548704*PRES), (long)(25.097422*PRES)},
  {(long)(-0.0*PRES), (long)(0.0*PRES), (long)(-28.98*PRES)},
  {(long)(-14.49*PRES), (long)(0.0*PRES), (long)(-25.097422*PRES)},
  {(long)(-25.097422*PRES), (long)(1.4e-05*PRES), (long)(-14.49*PRES)},
  {(long)(-0.0*PRES), (long)(-0.0*PRES), (long)(28.98*PRES)},
};

const unsigned char faces[TRICOUNT][3] PROGMEM = {
  {0, 1, 2},
  {2, 3, 0},
  {1, 4, 5},
  {5, 2, 1},
  {6, 7, 8},
  {8, 9, 6},
  {7, 3, 10},
  {10, 8, 7},
  {3, 2, 11},
  {11, 10, 3},
  {2, 5, 12},
  {12, 11, 2},
  {9, 8, 13},
  {13, 14, 9},
  {8, 10, 15},
  {15, 13, 8},
  {10, 11, 16},
  {16, 15, 10},
  {11, 12, 17},
  {17, 16, 11},
  {14, 13, 18},
  {18, 19, 14},
  {13, 15, 20},
  {20, 18, 13},
  {15, 16, 21},
  {21, 20, 15},
  {16, 17, 22},
  {22, 21, 16},
  {19, 18, 23},
  {23, 24, 19},
  {18, 20, 25},
  {25, 23, 18},
  {20, 21, 26},
  {26, 25, 20},
  {21, 22, 27},
  {27, 26, 21},
  {28, 29, 6},
  {29, 30, 7},
  {7, 6, 29},
  {30, 0, 3},
  {3, 7, 30},
  {4, 31, 5},
  {28, 6, 9},
  {5, 31, 12},
  {28, 9, 14},
  {12, 31, 17},
  {28, 14, 19},
  {17, 31, 22},
  {28, 19, 24},
  {22, 31, 27},
  {28, 24, 29},
  {24, 23, 30},
  {30, 29, 24},
  {23, 25, 0},
  {0, 30, 23},
  {25, 26, 1},
  {1, 0, 25},
  {4, 1, 26},
  {26, 27, 4},
  {27, 31, 4},
};

#endif // MESH_H
